/************************************************************************************/
/*  Program name CAPFAEXT_MASS_EXT_RET.sql                                         */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 22 DEC, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_MASS_EXT_RET';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_MASS_EXT_RET.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_MASS_EXT_RETIREMENTS
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.BATCH_NAME||CHR(9)||
				C1.MASS_EXTERNAL_RETIRE_ID||CHR(9)||
				C1.RETIREMENT_ID||CHR(9)||
				C1.BOOK_TYPE_CODE||CHR(9)||
				C1.REVIEW_STATUS||CHR(9)||
				C1.ASSET_ID||CHR(9)||
				C1.TRANSACTION_NAME||CHR(9)||
				C1.DATE_RETIRED||CHR(9)||
				C1.DATE_EFFECTIVE||CHR(9)||
				C1.COST_RETIRED||CHR(9)||
				C1.RETIREMENT_PRORATE_CONVENTION||CHR(9)||
				C1.UNITS||CHR(9)||
				C1.PERCENTAGE||CHR(9)||
				C1.COST_OF_REMOVAL||CHR(9)||
				C1.PROCEEDS_OF_SALE||CHR(9)||
				C1.RETIREMENT_TYPE_CODE||CHR(9)||
				C1.REFERENCE_NUM||CHR(9)||
				C1.SOLD_TO||CHR(9)||
				C1.TRADE_IN_ASSET_ID||CHR(9)||
				C1.CALC_GAIN_LOSS_FLAG||CHR(9)||
				C1.STL_METHOD_CODE||CHR(9)||
				C1.STL_LIFE_IN_MONTHS||CHR(9)||
				C1.STL_DEPRN_AMOUNT||CHR(9)||
				C1.CREATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
				C1.LAST_UPDATED_BY||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.TH_ATTRIBUTE_CATEGORY||CHR(9)||
				C1.TH_ATTRIBUTE1||CHR(9)||
				C1.TH_ATTRIBUTE2||CHR(9)||
				C1.TH_ATTRIBUTE3||CHR(9)||
				C1.TH_ATTRIBUTE4||CHR(9)||
				C1.TH_ATTRIBUTE5||CHR(9)||
				C1.TH_ATTRIBUTE6||CHR(9)||
				C1.TH_ATTRIBUTE7||CHR(9)||
				C1.TH_ATTRIBUTE8||CHR(9)||
				C1.TH_ATTRIBUTE9||CHR(9)||
				C1.TH_ATTRIBUTE10||CHR(9)||
				C1.TH_ATTRIBUTE11||CHR(9)||
				C1.TH_ATTRIBUTE12||CHR(9)||
				C1.TH_ATTRIBUTE13||CHR(9)||
				C1.TH_ATTRIBUTE14||CHR(9)||
				C1.TH_ATTRIBUTE15||CHR(9)||
				C1.ATTRIBUTE_CATEGORY||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.ATTRIBUTE11||CHR(9)||
				C1.ATTRIBUTE12||CHR(9)||
				C1.ATTRIBUTE13||CHR(9)||
				C1.ATTRIBUTE14||CHR(9)||
				C1.ATTRIBUTE15||CHR(9)||
				C1.DISTRIBUTION_ID||CHR(9)||
				C1.RETURN_TO_INVENTORY||CHR(9)||
				C1.CODE_COMBINATION_ID||CHR(9)||
				C1.LOCATION_ID||CHR(9)||
				C1.ASSIGNED_TO||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.CODE_COMBINATION_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
